# coding: utf-8

"""
    Demisto API

    This is the public REST API to integrate with the demisto server. HTTP request can be sent using any HTTP-client.  For an example dedicated client take a look at: https://github.com/demisto/demisto-py.  Requests must include API-key that can be generated in the Demisto web client under 'Settings' -> 'Integrations' -> 'API keys'   Optimistic Locking and Versioning\\:  When using Demisto REST API, you will need to make sure to work on the latest version of the item (incident, entry, etc.), otherwise, you will get a DB version error (which not allow you to override a newer item). In addition, you can pass 'version\\: -1' to force data override (make sure that other users data might be lost).  Assume that Alice and Bob both read the same data from Demisto server, then they both changed the data, and then both tried to write the new versions back to the server. Whose changes should be saved? Alice’s? Bob’s? To solve this, each data item in Demisto has a numeric incremental version. If Alice saved an item with version 4 and Bob trying to save the same item with version 3, Demisto will rollback Bob request and returns a DB version conflict error. Bob will need to get the latest item and work on it so Alice work will not get lost.  Example request using 'curl'\\:  ``` curl 'https://hostname:443/incidents/search' -H 'content-type: application/json' -H 'accept: application/json' -H 'Authorization: <API Key goes here>' --data-binary '{\"filter\":{\"query\":\"-status:closed -category:job\",\"period\":{\"by\":\"day\",\"fromValue\":7}}}' --compressed ```  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from demisto_client.demisto_api.models.automation_script_api import AutomationScriptAPI  # noqa: F401,E501


class AutomationScriptResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'python_enabled': 'bool',
        'scripts': 'list[AutomationScriptAPI]',
        'selected_script': 'dict(str, object)',
        'suggestions': 'list[str]'
    }

    attribute_map = {
        'python_enabled': 'pythonEnabled',
        'scripts': 'scripts',
        'selected_script': 'selectedScript',
        'suggestions': 'suggestions'
    }

    def __init__(self, python_enabled=None, scripts=None, selected_script=None, suggestions=None):  # noqa: E501
        """AutomationScriptResult - a model defined in Swagger"""  # noqa: E501

        self._python_enabled = None
        self._scripts = None
        self._selected_script = None
        self._suggestions = None
        self.discriminator = None

        if python_enabled is not None:
            self.python_enabled = python_enabled
        if scripts is not None:
            self.scripts = scripts
        if selected_script is not None:
            self.selected_script = selected_script
        if suggestions is not None:
            self.suggestions = suggestions

    @property
    def python_enabled(self):
        """Gets the python_enabled of this AutomationScriptResult.  # noqa: E501


        :return: The python_enabled of this AutomationScriptResult.  # noqa: E501
        :rtype: bool
        """
        return self._python_enabled

    @python_enabled.setter
    def python_enabled(self, python_enabled):
        """Sets the python_enabled of this AutomationScriptResult.


        :param python_enabled: The python_enabled of this AutomationScriptResult.  # noqa: E501
        :type: bool
        """

        self._python_enabled = python_enabled

    @property
    def scripts(self):
        """Gets the scripts of this AutomationScriptResult.  # noqa: E501


        :return: The scripts of this AutomationScriptResult.  # noqa: E501
        :rtype: list[AutomationScriptAPI]
        """
        return self._scripts

    @scripts.setter
    def scripts(self, scripts):
        """Sets the scripts of this AutomationScriptResult.


        :param scripts: The scripts of this AutomationScriptResult.  # noqa: E501
        :type: list[AutomationScriptAPI]
        """

        self._scripts = scripts

    @property
    def selected_script(self):
        """Gets the selected_script of this AutomationScriptResult.  # noqa: E501


        :return: The selected_script of this AutomationScriptResult.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._selected_script

    @selected_script.setter
    def selected_script(self, selected_script):
        """Sets the selected_script of this AutomationScriptResult.


        :param selected_script: The selected_script of this AutomationScriptResult.  # noqa: E501
        :type: dict(str, object)
        """

        self._selected_script = selected_script

    @property
    def suggestions(self):
        """Gets the suggestions of this AutomationScriptResult.  # noqa: E501


        :return: The suggestions of this AutomationScriptResult.  # noqa: E501
        :rtype: list[str]
        """
        return self._suggestions

    @suggestions.setter
    def suggestions(self, suggestions):
        """Sets the suggestions of this AutomationScriptResult.


        :param suggestions: The suggestions of this AutomationScriptResult.  # noqa: E501
        :type: list[str]
        """

        self._suggestions = suggestions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AutomationScriptResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AutomationScriptResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
